/*
* Licensed to the Apache Software Foundation (ASF) under one or more
* contributor license agreements.  See the NOTICE file distributed with
* this work for additional information regarding copyright ownership.
* The ASF licenses this file to You under the Apache License, Version 2.0
* (the "License"); you may not use this file except in compliance with
* the License.  You may obtain a copy of the License at
*
*     http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing, software
* distributed under the License is distributed on an "AS IS" BASIS,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
* See the License for the specific language governing permissions and
* limitations under the License.
*/

    package com.ywt.gapi.im;

import org.apache.dubbo.common.stream.StreamObserver;
import org.apache.dubbo.common.URL;
import org.apache.dubbo.rpc.Invoker;
import org.apache.dubbo.rpc.PathResolver;
import org.apache.dubbo.rpc.RpcException;
import org.apache.dubbo.rpc.ServerService;
import org.apache.dubbo.rpc.TriRpcStatus;
import org.apache.dubbo.rpc.model.MethodDescriptor;
import org.apache.dubbo.rpc.model.ServiceDescriptor;
import org.apache.dubbo.rpc.model.StubMethodDescriptor;
import org.apache.dubbo.rpc.model.StubServiceDescriptor;
import org.apache.dubbo.rpc.stub.BiStreamMethodHandler;
import org.apache.dubbo.rpc.stub.ServerStreamMethodHandler;
import org.apache.dubbo.rpc.stub.StubInvocationUtil;
import org.apache.dubbo.rpc.stub.StubInvoker;
import org.apache.dubbo.rpc.stub.StubMethodHandler;
import org.apache.dubbo.rpc.stub.StubSuppliers;
import org.apache.dubbo.rpc.stub.UnaryStubMethodHandler;

import com.google.protobuf.Message;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiConsumer;
import java.util.concurrent.CompletableFuture;

public final class DubboAliSMSProxyServiceTriple {

    public static final String SERVICE_NAME = AliSMSProxyService.SERVICE_NAME;

    private static final StubServiceDescriptor serviceDescriptor = new StubServiceDescriptor(SERVICE_NAME,AliSMSProxyService.class);

    static {
        org.apache.dubbo.rpc.protocol.tri.service.SchemaDescriptorRegistry.addSchemaDescriptor(SERVICE_NAME,ImProto.getDescriptor());
        StubSuppliers.addSupplier(SERVICE_NAME, DubboAliSMSProxyServiceTriple::newStub);
        StubSuppliers.addSupplier(AliSMSProxyService.JAVA_SERVICE_NAME,  DubboAliSMSProxyServiceTriple::newStub);
        StubSuppliers.addDescriptor(SERVICE_NAME, serviceDescriptor);
        StubSuppliers.addDescriptor(AliSMSProxyService.JAVA_SERVICE_NAME, serviceDescriptor);
    }

    @SuppressWarnings("all")
    public static AliSMSProxyService newStub(Invoker<?> invoker) {
        return new AliSMSProxyServiceStub((Invoker<AliSMSProxyService>)invoker);
    }

    private static final StubMethodDescriptor sendSMSMethod = new StubMethodDescriptor("sendSMS",
    com.ywt.gapi.im.AliSendSMSRequest.class, com.ywt.gapi.im.AliSendSMSResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.im.AliSendSMSRequest::parseFrom,
    com.ywt.gapi.im.AliSendSMSResponse::parseFrom);

    private static final StubMethodDescriptor sendSMSAsyncMethod = new StubMethodDescriptor("sendSMS",
    com.ywt.gapi.im.AliSendSMSRequest.class, java.util.concurrent.CompletableFuture.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.im.AliSendSMSRequest::parseFrom,
    com.ywt.gapi.im.AliSendSMSResponse::parseFrom);

    private static final StubMethodDescriptor sendSMSProxyAsyncMethod = new StubMethodDescriptor("sendSMSAsync",
    com.ywt.gapi.im.AliSendSMSRequest.class, com.ywt.gapi.im.AliSendSMSResponse.class, serviceDescriptor, MethodDescriptor.RpcType.UNARY,
    obj -> ((Message) obj).toByteArray(), obj -> ((Message) obj).toByteArray(), com.ywt.gapi.im.AliSendSMSRequest::parseFrom,
    com.ywt.gapi.im.AliSendSMSResponse::parseFrom);





    public static class AliSMSProxyServiceStub implements AliSMSProxyService{
        private final Invoker<AliSMSProxyService> invoker;

        public AliSMSProxyServiceStub(Invoker<AliSMSProxyService> invoker) {
            this.invoker = invoker;
        }

        @Override
        public com.ywt.gapi.im.AliSendSMSResponse sendSMS(com.ywt.gapi.im.AliSendSMSRequest request){
            return StubInvocationUtil.unaryCall(invoker, sendSMSMethod, request);
        }

        public CompletableFuture<com.ywt.gapi.im.AliSendSMSResponse> sendSMSAsync(com.ywt.gapi.im.AliSendSMSRequest request){
            return StubInvocationUtil.unaryCall(invoker, sendSMSAsyncMethod, request);
        }

        @Override
        public void sendSMS(com.ywt.gapi.im.AliSendSMSRequest request, StreamObserver<com.ywt.gapi.im.AliSendSMSResponse> responseObserver){
            StubInvocationUtil.unaryCall(invoker, sendSMSMethod , request, responseObserver);
        }



    }

    public static abstract class AliSMSProxyServiceImplBase implements AliSMSProxyService, ServerService<AliSMSProxyService> {

        private <T, R> BiConsumer<T, StreamObserver<R>> syncToAsync(java.util.function.Function<T, R> syncFun) {
            return new BiConsumer<T, StreamObserver<R>>() {
                @Override
                public void accept(T t, StreamObserver<R> observer) {
                    try {
                        R ret = syncFun.apply(t);
                        observer.onNext(ret);
                        observer.onCompleted();
                    } catch (Throwable e) {
                        observer.onError(e);
                    }
                }
            };
        }

        @Override
        public final Invoker<AliSMSProxyService> getInvoker(URL url) {
            PathResolver pathResolver = url.getOrDefaultFrameworkModel()
            .getExtensionLoader(PathResolver.class)
            .getDefaultExtension();
            Map<String,StubMethodHandler<?, ?>> handlers = new HashMap<>();

            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/sendSMS" );
            pathResolver.addNativeStub( "/" + SERVICE_NAME + "/sendSMSAsync" );

            BiConsumer<com.ywt.gapi.im.AliSendSMSRequest, StreamObserver<com.ywt.gapi.im.AliSendSMSResponse>> sendSMSFunc = this::sendSMS;
            handlers.put(sendSMSMethod.getMethodName(), new UnaryStubMethodHandler<>(sendSMSFunc));
            BiConsumer<com.ywt.gapi.im.AliSendSMSRequest, StreamObserver<com.ywt.gapi.im.AliSendSMSResponse>> sendSMSAsyncFunc = syncToAsync(this::sendSMS);
            handlers.put(sendSMSProxyAsyncMethod.getMethodName(), new UnaryStubMethodHandler<>(sendSMSAsyncFunc));




            return new StubInvoker<>(this, url, AliSMSProxyService.class, handlers);
        }


        @Override
        public com.ywt.gapi.im.AliSendSMSResponse sendSMS(com.ywt.gapi.im.AliSendSMSRequest request){
            throw unimplementedMethodException(sendSMSMethod);
        }





        @Override
        public final ServiceDescriptor getServiceDescriptor() {
            return serviceDescriptor;
        }
        private RpcException unimplementedMethodException(StubMethodDescriptor methodDescriptor) {
            return TriRpcStatus.UNIMPLEMENTED.withDescription(String.format("Method %s is unimplemented",
                "/" + serviceDescriptor.getInterfaceName() + "/" + methodDescriptor.getMethodName())).asException();
        }
    }

}
